<?php

$dom = new DOMDocument();
//$dom->preserveWhiteSpace=false;

//Load an XML from a file
$dom->load("Book.xml");

//Recursive through
$root = $dom->firstChild;
//getNodesInfo($root);

//Creating a new element and add it to the root using the appendChild method
$newElement = $dom->createElement('bibliography','Martin Didier, Professional XML');

//The appendNewChild function call
//appendNewChild($root,$newElement);
//getNodesInfo($root);

//adding a new children <foreword> using the insertBefore method
$newElement = $dom->createElement('foreword','What I love about this book is that it grew out of just such a process.');

//Setting the reference node
$allContents = $dom->getElementsByTagName('publisher');
$contents = $allContents->item(0);

//The insertNewChild function call
//insertNewChild($contents,$newElement);
//getNodesInfo($root);

//Setting the reference node
$bibliography = $root->getElementsByTagName('bibliography')->item(0);
//The removingChild function call
removingChild($root,$bibliography);
//getNodesInfo($root);

 
//Setting the reference node
$element = $dom->getElementsByTagName('ISBN')->item(0); 
//Creating the new element node which will be replaced the $element node
$code = $dom->createElement('code', '909090');
//The replacingNode function call
replacingNode($code,$element);
//getNodesInfo($root);


//Setting the reference node
$author = $root->getElementsByTagName('author')->item(0);
//The cloningNode function call
//cloningNode($author); 
//getNodesInfo($root);


//Checking if two nodes are equals
$author1 = $root->getElementsByTagName('autor')->item(0);
$author2 = $root->getElementsByTagName('autor')->item(1);
//verifyNodes($author1,$author2);
//getNodesInfo($root);

function getNodesInfo($node)
	{
	if ($node->hasChildNodes())
	    {
		$subNodes = $node->childNodes;
		foreach ($subNodes as $subNode)
			{
			if (($subNode->nodeType != 3)&&($subNode->nodeType != 8))	
				{
				echo "Node name: ".trim($subNode->nodeName)."<br />";
				echo "Node value: ".trim($subNode->nodeValue)."<br />";
				}
			getNodesInfo($subNode);			
			}
		}		
	}	

	
//The function which will append a new child to the root
function appendNewChild($currentNode, $node)
	{
    //appending a new children to the root
	$currentNode->appendChild($node);
	}

//The function which will insert a new child to the first occurance of the $currentNode node
function insertNewChild($currentNode, $node)
	{
	$currentNode->insertBefore($node, $currentNode->firstChild);	
	}
	
//This function remove the $currentNode node
function removingChild($node,$currentNode)
	{
	$oldbibliography = $node->removeChild($currentNode);	
	}	

//This function replace the $currentNode node with the $node node 
function replacingNode($currentNode, $node)
	{
	$node->parentNode->replaceChild($currentNode, $node);	
	}	

//This function clone the $currentNode
function cloningNode($currentNode)
	{
      
	  $clonenode = $currentNode -> cloneNode(true);
      $newnode = $currentNode->appendChild($clonenode);	
	}

//This function check if two nodes are equals
function verifyNodes($currentNode, $node)
	{
	if (($currentNode->isSameNode($node))==true)
	{
	echo "These two nodes are the same";
	//deleting one of them by using the above removingChild function
	//removingChild($node);	
	}	
	}

?>
