<?php

$olddoc = new DOMDocument;
$olddoc->load("Book_continue.xml");

// The node we want to import to a new document
$node = $olddoc->getElementsByTagName("continue")->item(0);

$newdoc = new DOMDocument;
$newdoc->formatOutput = true;
$newdoc->load("Book.xml");

// Import the node, and all its children, to the document
$node = $newdoc->importNode($node, true);

// And then append it to the root node
$newdoc->documentElement->appendChild($node);

echo "\nThe 'new document' after copying the nodes into it:\n";
$root = $newdoc->firstChild;

function getNodesInfo($node)
	{
	if ($node->hasChildNodes())
	    {
		$subNodes = $node->childNodes;
		foreach ($subNodes as $subNode)
			{
			if (($subNode->nodeType != 3) || (($subNode->nodeType == 3)&&(strlen(trim($subNode->wholeText))>=1)))	
				{
				echo "Node name: ".trim($subNode->nodeName)."<br />";
				echo "Node value: ".trim($subNode->nodeValue)."<br />";
				}
			getNodesInfo($subNode);			
			}
		}		
	}

getNodesInfo($root);	
?>

